/**  版本信息模板在安装目录下，可自行修改。
* T_Exp_ExtensionBase.cs
*
* 功 能： N/A
* 类 名： T_Exp_ExtensionBase
*
* Ver    变更日期             负责人  变更内容
* ───────────────────────────────────
* V0.01  2015/8/3 10:27:27   N/A    初版
*
* Copyright (c) 2012 Maticsoft Corporation. All rights reserved.
*┌──────────────────────────────────┐
*│　此技术信息为本公司机密信息，未经本公司书面同意禁止向第三方披露．　│
*│　版权所有：动软卓越（北京）科技有限公司　　　　　　　　　　　　　　│
*└──────────────────────────────────┘
*/
using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using HySoft.DBUtility;//Please add references
namespace HySoft.BaseCallCenter.DAL
{
	/// <summary>
	/// 数据访问类:T_Exp_ExtensionBase
	/// </summary>
	public partial class T_Exp_ExtensionBase
	{
		public T_Exp_ExtensionBase()
		{}
		#region  BasicMethod

		/// <summary>
		/// 得到最大ID
		/// </summary>
		public int GetMaxId()
		{
		return DbHelperSQL.GetMaxID("F_ExpBaseID", "T_Exp_ExtensionBase"); 
		}

		/// <summary>
		/// 是否存在该记录
		/// </summary>
		public bool Exists(int F_ExpBaseID)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("select count(1) from T_Exp_ExtensionBase");
			strSql.Append(" where F_ExpBaseID=@F_ExpBaseID");
			SqlParameter[] parameters = {
					new SqlParameter("@F_ExpBaseID", SqlDbType.Int,4)
			};
			parameters[0].Value = F_ExpBaseID;

			return DbHelperSQL.Exists(strSql.ToString(),parameters);
		}


		/// <summary>
		/// 增加一条数据
		/// </summary>
		public int Add(HySoft.BaseCallCenter.Model.T_Exp_ExtensionBase model)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("insert into T_Exp_ExtensionBase(");
			strSql.Append("F_TableName,F_FieldName,F_ShowName,F_ShowType,F_DictValue,F_SortValue,F_AddTime,F_AddUseId)");
			strSql.Append(" values (");
			strSql.Append("@F_TableName,@F_FieldName,@F_ShowName,@F_ShowType,@F_DictValue,@F_SortValue,@F_AddTime,@F_AddUseId)");
			strSql.Append(";select @@IDENTITY");
			SqlParameter[] parameters = {
					new SqlParameter("@F_TableName", SqlDbType.VarChar,30),
					new SqlParameter("@F_FieldName", SqlDbType.VarChar,15),
					new SqlParameter("@F_ShowName", SqlDbType.NVarChar,15),
					new SqlParameter("@F_ShowType", SqlDbType.Int,4),
					new SqlParameter("@F_DictValue", SqlDbType.VarChar,50),
					new SqlParameter("@F_SortValue", SqlDbType.Int,4),
					new SqlParameter("@F_AddTime", SqlDbType.DateTime),
					new SqlParameter("@F_AddUseId", SqlDbType.Int,4)};
			parameters[0].Value = model.F_TableName;
			parameters[1].Value = model.F_FieldName;
			parameters[2].Value = model.F_ShowName;
			parameters[3].Value = model.F_ShowType;
			parameters[4].Value = model.F_DictValue;
			parameters[5].Value = model.F_SortValue;
			parameters[6].Value = model.F_AddTime;
			parameters[7].Value = model.F_AddUseId;

			object obj = DbHelperSQL.GetSingle(strSql.ToString(),parameters);
			if (obj == null)
			{
				return 0;
			}
			else
			{
				return Convert.ToInt32(obj);
			}
		}
		/// <summary>
		/// 更新一条数据
		/// </summary>
		public bool Update(HySoft.BaseCallCenter.Model.T_Exp_ExtensionBase model)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("update T_Exp_ExtensionBase set ");
			strSql.Append("F_TableName=@F_TableName,");
			strSql.Append("F_FieldName=@F_FieldName,");
			strSql.Append("F_ShowName=@F_ShowName,");
			strSql.Append("F_ShowType=@F_ShowType,");
			strSql.Append("F_DictValue=@F_DictValue,");
			strSql.Append("F_SortValue=@F_SortValue,");
			strSql.Append("F_AddTime=@F_AddTime,");
			strSql.Append("F_AddUseId=@F_AddUseId");
			strSql.Append(" where F_ExpBaseID=@F_ExpBaseID");
			SqlParameter[] parameters = {
					new SqlParameter("@F_TableName", SqlDbType.VarChar,30),
					new SqlParameter("@F_FieldName", SqlDbType.VarChar,15),
					new SqlParameter("@F_ShowName", SqlDbType.NVarChar,15),
					new SqlParameter("@F_ShowType", SqlDbType.Int,4),
					new SqlParameter("@F_DictValue", SqlDbType.VarChar,50),
					new SqlParameter("@F_SortValue", SqlDbType.Int,4),
					new SqlParameter("@F_AddTime", SqlDbType.DateTime),
					new SqlParameter("@F_AddUseId", SqlDbType.Int,4),
					new SqlParameter("@F_ExpBaseID", SqlDbType.Int,4)};
			parameters[0].Value = model.F_TableName;
			parameters[1].Value = model.F_FieldName;
			parameters[2].Value = model.F_ShowName;
			parameters[3].Value = model.F_ShowType;
			parameters[4].Value = model.F_DictValue;
			parameters[5].Value = model.F_SortValue;
			parameters[6].Value = model.F_AddTime;
			parameters[7].Value = model.F_AddUseId;
			parameters[8].Value = model.F_ExpBaseID;

			int rows=DbHelperSQL.ExecuteSql(strSql.ToString(),parameters);
			if (rows > 0)
			{
				return true;
			}
			else
			{
				return false;
			}
		}

		/// <summary>
		/// 删除一条数据
		/// </summary>
		public bool Delete(int F_ExpBaseID)
		{
			
			StringBuilder strSql=new StringBuilder();
			strSql.Append("delete from T_Exp_ExtensionBase ");
			strSql.Append(" where F_ExpBaseID=@F_ExpBaseID");
			SqlParameter[] parameters = {
					new SqlParameter("@F_ExpBaseID", SqlDbType.Int,4)
			};
			parameters[0].Value = F_ExpBaseID;

			int rows=DbHelperSQL.ExecuteSql(strSql.ToString(),parameters);
			if (rows > 0)
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		/// <summary>
		/// 批量删除数据
		/// </summary>
		public bool DeleteList(string F_ExpBaseIDlist )
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("delete from T_Exp_ExtensionBase ");
			strSql.Append(" where F_ExpBaseID in ("+F_ExpBaseIDlist + ")  ");
			int rows=DbHelperSQL.ExecuteSql(strSql.ToString());
			if (rows > 0)
			{
				return true;
			}
			else
			{
				return false;
			}
		}


		/// <summary>
		/// 得到一个对象实体
		/// </summary>
		public HySoft.BaseCallCenter.Model.T_Exp_ExtensionBase GetModel(int F_ExpBaseID)
		{
			
			StringBuilder strSql=new StringBuilder();
			strSql.Append("select  top 1 F_ExpBaseID,F_TableName,F_FieldName,F_ShowName,F_ShowType,F_DictValue,F_SortValue,F_AddTime,F_AddUseId from T_Exp_ExtensionBase ");
			strSql.Append(" where F_ExpBaseID=@F_ExpBaseID");
			SqlParameter[] parameters = {
					new SqlParameter("@F_ExpBaseID", SqlDbType.Int,4)
			};
			parameters[0].Value = F_ExpBaseID;

			HySoft.BaseCallCenter.Model.T_Exp_ExtensionBase model=new HySoft.BaseCallCenter.Model.T_Exp_ExtensionBase();
			DataSet ds=DbHelperSQL.Query(strSql.ToString(),parameters);
			if(ds.Tables[0].Rows.Count>0)
			{
				return DataRowToModel(ds.Tables[0].Rows[0]);
			}
			else
			{
				return null;
			}
		}


		/// <summary>
		/// 得到一个对象实体
		/// </summary>
		public HySoft.BaseCallCenter.Model.T_Exp_ExtensionBase DataRowToModel(DataRow row)
		{
			HySoft.BaseCallCenter.Model.T_Exp_ExtensionBase model=new HySoft.BaseCallCenter.Model.T_Exp_ExtensionBase();
			if (row != null)
			{
				if(row["F_ExpBaseID"]!=null && row["F_ExpBaseID"].ToString()!="")
				{
					model.F_ExpBaseID=int.Parse(row["F_ExpBaseID"].ToString());
				}
				if(row["F_TableName"]!=null)
				{
					model.F_TableName=row["F_TableName"].ToString();
				}
				if(row["F_FieldName"]!=null)
				{
					model.F_FieldName=row["F_FieldName"].ToString();
				}
				if(row["F_ShowName"]!=null)
				{
					model.F_ShowName=row["F_ShowName"].ToString();
				}
				if(row["F_ShowType"]!=null && row["F_ShowType"].ToString()!="")
				{
					model.F_ShowType=int.Parse(row["F_ShowType"].ToString());
				}
				if(row["F_DictValue"]!=null)
				{
					model.F_DictValue=row["F_DictValue"].ToString();
				}
				if(row["F_SortValue"]!=null && row["F_SortValue"].ToString()!="")
				{
					model.F_SortValue=int.Parse(row["F_SortValue"].ToString());
				}
				if(row["F_AddTime"]!=null && row["F_AddTime"].ToString()!="")
				{
					model.F_AddTime=DateTime.Parse(row["F_AddTime"].ToString());
				}
				if(row["F_AddUseId"]!=null && row["F_AddUseId"].ToString()!="")
				{
					model.F_AddUseId=int.Parse(row["F_AddUseId"].ToString());
				}
			}
			return model;
		}

		/// <summary>
		/// 获得数据列表
		/// </summary>
		public DataSet GetList(string strWhere)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("select F_ExpBaseID,F_TableName,F_FieldName,F_ShowName,F_ShowType,F_DictValue,F_SortValue,F_AddTime,F_AddUseId ");
			strSql.Append(" FROM T_Exp_ExtensionBase ");
			if(strWhere.Trim()!="")
			{
				strSql.Append(" where "+strWhere);
			}
			return DbHelperSQL.Query(strSql.ToString());
		}

		/// <summary>
		/// 获得前几行数据
		/// </summary>
		public DataSet GetList(int Top,string strWhere,string filedOrder)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("select ");
			if(Top>0)
			{
				strSql.Append(" top "+Top.ToString());
			}
			strSql.Append(" F_ExpBaseID,F_TableName,F_FieldName,F_ShowName,F_ShowType,F_DictValue,F_SortValue,F_AddTime,F_AddUseId ");
			strSql.Append(" FROM T_Exp_ExtensionBase ");
			if(strWhere.Trim()!="")
			{
				strSql.Append(" where "+strWhere);
			}
			strSql.Append(" order by " + filedOrder);
			return DbHelperSQL.Query(strSql.ToString());
		}

		/// <summary>
		/// 获取记录总数
		/// </summary>
		public int GetRecordCount(string strWhere)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("select count(1) FROM T_Exp_ExtensionBase ");
			if(strWhere.Trim()!="")
			{
				strSql.Append(" where "+strWhere);
			}
			object obj = DbHelperSQL.GetSingle(strSql.ToString());
			if (obj == null)
			{
				return 0;
			}
			else
			{
				return Convert.ToInt32(obj);
			}
		}
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("SELECT * FROM ( ");
			strSql.Append(" SELECT ROW_NUMBER() OVER (");
			if (!string.IsNullOrEmpty(orderby.Trim()))
			{
				strSql.Append("order by T." + orderby );
			}
			else
			{
				strSql.Append("order by T.F_ExpBaseID desc");
			}
			strSql.Append(")AS Row, T.*  from T_Exp_ExtensionBase T ");
			if (!string.IsNullOrEmpty(strWhere.Trim()))
			{
				strSql.Append(" WHERE " + strWhere);
			}
			strSql.Append(" ) TT");
			strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
			return DbHelperSQL.Query(strSql.ToString());
		}

		/*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Exp_ExtensionBase";
			parameters[1].Value = "F_ExpBaseID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

		#endregion  BasicMethod
		#region  ExtensionMethod

		#endregion  ExtensionMethod
	}
}

